#pragma NOIV                    // Do not generate interrupt vectors

#define ALLOCATE_EXTERN  
#include "fx2.h"
#include "fx2regs.h"
#include "fx2sdly.h"             // Define _IFREQ and _CFREQ above this #include



void TD_Init(void);
void TD_Poll(void);





#define GPIFTRIGWR 0
#define GPIFTRIGRD 4

#define GPIF_EP2 0
#define GPIF_EP4 1
#define GPIF_EP6 2
#define GPIF_EP8 3



sbit PA_0 = IOA^0;
sbit PA_1 = IOA^1;

sbit PD_0 = IOD^0;
sbit PD_1 = IOD^1;
sbit PD_2 = IOD^2;
sbit PD_3 = IOD^3;

BYTE xfer_len[4];
BYTE xfer_in = FALSE;
BYTE xfer_out = FALSE;

BYTE commands[13];
BYTE status[13];


void delay(DWORD i)
{
	DWORD count=0;
	do{
	count++;
	}while(count!=i);
}
BYTE INT2BCD(BYTE i)
{
	return ((i / 10) << 4) | (i % 10);
}


unsigned long LBA2MSF(unsigned long LBA) //BCD format!!
/* convert LBA to MSF
   in:LBA = unsigned long LBA number
   out: MSF = unsigned long,bit 0- 7:F
							bit 8-15:S
							bit16-23:M
*/
{
 unsigned long i,j;

// LBA=LBA+150;
 i=(LBA/4500);
 LBA=LBA-(i*4500);
 //i=i*0x10000;
// *((BYTE*)&i+1)=*((BYTE*)&i+3);
// *((BYTE*)&i+3)=0;
 j=(LBA/75);
 LBA=LBA-(j*75);
// *((BYTE*)&j+2)=*((BYTE*)&j+3);
// i=i+(j<<8)+LBA;
// i=i+j+LBA;
 
*((BYTE*)&j+0)=0;
*((BYTE*)&j+1)=INT2BCD(*((BYTE*)&i+3));
*((BYTE*)&j+2)=INT2BCD(*((BYTE*)&j+3));
*((BYTE*)&j+3)=INT2BCD(*((BYTE*)&LBA+3));

 return j;

}


BOOL check_command_parity(BYTE *buffer)
{
	BYTE	i,parity=0;
	for(i=0;i<4;i++)
		parity+=buffer[i];
	parity+=buffer[10];
	parity= ~parity;
	if(parity==buffer[11])
		return TRUE;
	else
		return FALSE;
	
}
BOOL check_parity(BYTE *buffer)
{
	BYTE	i,parity=0;
	for(i=0;i<11;i++)
		parity+=buffer[i];
	parity= ~parity;
	if(parity==buffer[11])
		return TRUE;
	else
		return FALSE;
	
}
void write_parity(BYTE *buffer)
{
	BYTE	i,parity=0;
	for(i=0;i<11;i++)		//haha! bytes 0-10 ,parity at 11!!
		parity+=buffer[i];
	parity= ~parity;
	buffer[11]=parity;
}
BOOL read_commands_new(char *buffer)
{
	BYTE i,j;

	PD_2=1;	//read
	PA_1=1;	//reset pointer
	PD_1=1;	//commands
	PA_1=0;	//select commands
	OEB=0;
	for(i=0;i<13;i++)
	{
		PA_0=0;
		j=IOB;
		if(i==0 && j==0)
		{
			PA_0=1;
			return FALSE;
		}
		buffer[i]=j;
		PA_0=1;
	}
	return check_command_parity(buffer);

}

void read_commands(char *buffer)
{
	BYTE i;

	PD_2=1;	//read
	PA_1=1;	//reset pointer
	PD_1=1;	//commands
	PA_1=0;	//select commands
	OEB=0;
	for(i=0;i<13;i++)
	{
		PA_0=0;
		buffer[i]=IOB;
		PA_0=1;
	}

}
void read_status(char *buffer)
{
	BYTE i;

	PD_2=1;	//read
	PA_1=1;	//reset pointer
	PD_1=0;	//status
	PA_1=0;	//select status
	OEB=0;
	for(i=0;i<13;i++)
	{
		PA_0=0;
		buffer[i]=IOB;
		PA_0=1;
	}

}
void read_cd_status(char *buffer)
{
	BYTE i,tbuf[13];
	static BYTE last;

	PD_2=1;	//read
	PA_1=0;	//reset pointer
	PD_1=1;	//status
	PA_1=1;	//select status
	OEB=0;

	for(i=0;i<13;i++)
	{
		PA_0=0;
		buffer[i]=IOB;
		PA_0=1;
	}
/*
	if(last!=tbuf[11])
		for(i=0;i<13;i++)
			buffer[i]=tbuf[i];
	last=tbuf[11];
*/
}
void write_status(char *buffer)
{
	BYTE i;

	PA_0=1;	//disable write latch
	PD_2=0;	//write data mode
	PA_1=0;	//reset pointer
	PA_1=1;	
	PD_1=0;	//status
	OEB=0xFF;
	for(i=0;i<13;i++)
	{
		PA_0=0;
		IOB=buffer[i];
		PA_0=1;
	}
	OEB=0;
	PD_2=1;	//go back to read mode

}
void write_msf_data(char *buffer)
{
	WORD i;

	PA_0=1;	//disable write latch
	PD_2=0;	//write data mode
	PA_1=0;	//reset pointer
	PA_1=1;	
	PD_1=1;	//msf
	OEB=0xFF;
	for(i=0;i<3;i++)
	{
		PA_0=0;
		IOB=buffer[i+1];	//0,M,S,F so skip the first byte
		PA_0=1;
	}
	OEB=0;
	PD_2=1;	//go back to read mode
	
}
void send_data_pc(char *buffer,BYTE length)
{
	BYTE i;
	WORD j;
	j=0;
	do
	{
		if(j>65000)
			break;
		j++;
	}while(!(EP68FIFOFLGS & 0x20  ));

	FIFORESET=0x80;
	FIFORESET=0x08;
	FIFORESET=0x00;
	for(i=0;i<length;i++)
	{
		EP8FIFOBUF[i]=buffer[i];
	}
	EP8BCH=0;
	SYNCDELAY;
	EP8BCL=length;

}

void get_lba(BYTE *buffer,BYTE *lba)
{
	 lba[0]=0;
	 lba[1]=buffer[1];
	 lba[2]=buffer[2];
	 lba[3]=buffer[3];
}
BYTE mod_step=0;
BYTE doonce=0;
void TD_Poll( void )
{ 
	BYTE i;
	WORD timeout=0;
	BYTE buffer[26];
	BYTE last_parity;
	static DWORD starting_lba;
	static BYTE  last_command;
	static DWORD lba,msf;
	static BYTE  last_rdy0,last_rdy1;
	static char lba_offset=0;
	  
/*
	--PD.0	1=take over command interface
	--PD.3	1=take over sector data
			--PD.2 1=read from FPGA
			--read commands and status and cd_status only
			--PA.0 inc read pointer /
			--PA.1 reset other pointer
			--PD.1 select which data
			
			--PD.2 0=write to FPGA	(make sure PA.0=1 before PD.2=0)
			--write status and sector data only
			--PD.1 select 1=msf or 0=status
			--PA.0 validate data low, increment pointer on rise/
			--PA.1 0=reset pointer			
*/

	i=GPIFREADYSTAT&2;
 	if(read_commands_new(commands) )
	{
		get_lba(commands,(BYTE*)&lba);
		if(lba>=0x3ef00 && commands[0]==2)
		{
			status[0]=0xB6;
			status[1]=0x44; //0x44;
			status[2]=0xF1;
			status[3]=*((BYTE*)&lba+1);
			status[4]=*((BYTE*)&lba+2);
			status[5]=*((BYTE*)&lba+3);
			status[6]=9;
			status[7]=9;
			status[8]=9;
			status[9]=9;
			status[10]=0;
			write_parity(status);
			write_status(status);

		}
//		if(lba==0x95 && commands[0]==6)	//this is possible begin auth process
		//FPGA will disable a command to high LBA so no need to prepare for it
		if(lba>=0x3d000 && commands[0]==2)	//this is a definate authenticate process
			mod_step=1;
		else if(lba<0x3d000 && commands[0]!=0) //where done ,reset modchip state
			mod_step=0;
		else if(lba>=0x3df00 && commands[0]==6)
		{
			mod_step=2;
			starting_lba=lba-4;
		}

	}
	last_rdy1=GPIFREADYSTAT&2;
	switch(mod_step)
	{
		case 1:
			PD_0=1;
			last_rdy0=GPIFREADYSTAT&1;
			break;
		case 2:
			msf=LBA2MSF(starting_lba);
			status[0]=0x36;
			status[1]=0x01;
			status[2]=0xAA;
			status[3]=0x01;
			status[4]=*((BYTE*)&msf+1);
			status[5]=*((BYTE*)&msf+2);
			status[6]=*((BYTE*)&msf+3);
			status[7]=4; //6;
			status[8]=*((BYTE*)&msf+1);
			status[9]=*((BYTE*)&msf+2);
			status[10]=*((BYTE*)&msf+3);

			write_parity(status);	//update status buffer with correct parity, YES the CORRECT PARITY

			//we wait for new sector to roll around so we can increment lba
			i=GPIFREADYSTAT&1;
			if(i!=last_rdy0)
			{
			write_status(status);
			write_msf_data(&msf);
			starting_lba++;
			PD_3=1;
			}
			last_rdy0=GPIFREADYSTAT&1;
			break;

		default:
			PD_3=0;
			PD_0=0;
			break;
	}

	//all this here below is for debuggin purposes
	if(!(EP2468STAT & bmEP4EMPTY) && (EP2468STAT & bmEP2EMPTY)) 
	{
		switch(EP4FIFOBUF[0])
		{
			case 0x12:
				buffer[0]=mod_step;
				send_data_pc(buffer,20);
				break;
			case 0x13:
				mod_step=0;
				break;
			case 0x14:
				send_data_pc(commands,20);
				break;
			case 0x15:
				read_commands(buffer);
				send_data_pc(buffer,20);
				break;
			case 0x16:	//write status data
				for(i=0;i<13;i++)
					buffer[i]=EP4FIFOBUF[1+i];			
				write_status(buffer);
				break;
			case 0x17:	//read status data
				read_status(buffer);
				send_data_pc(buffer,20);
				break;
		    case 0x18: //write sector data
				write_msf_data(EP4FIFOBUF+1);
				break;
			case 0x19://ready flag
				buffer[0]=GPIFREADYSTAT;
				send_data_pc(buffer,20);
				break;
			case 0x1A:	//lba
//				lba=0x30000;
//				lba=LBA2MSF(lba);
				for(i=0;i<4;i++)
				{
				buffer[i]=*((BYTE*)&lba+i);
				}
				send_data_pc(buffer,20);
				break;
			case 0x1B:	//enable sector overwrite
				PD_3=1;
				break;
			case 0x1C:	//disable sector overwrite
				PD_3=0;
				break;
			case 0x1D:	//read commands and status
				for(i=0;i<13;i++)
					buffer[i]=commands[i];
//				read_cd_status(&buffer+13);
				for(i=0;i<13;i++)
					buffer[i+13]=status[i];
//				read_status(&buffer+13);
				send_data_pc(buffer,30);
				break;
			case 0x1E:
				starting_lba=starting_lba-lba_offset;
				for(i=0;i<4;i++)
				{
				buffer[i]=*((BYTE*)&starting_lba+i);
				}
				send_data_pc(buffer,20);
				break;
			case 0x1F:
				lba_offset--;
				buffer[0]=lba_offset;
				send_data_pc(buffer,20);
				break;
			case 0x20:
				lba_offset++;
				buffer[0]=lba_offset;
				send_data_pc(buffer,20);
				break;
			case 0x21:
				read_cd_status(buffer);
				send_data_pc(buffer,20);
				break;
	
		}
		
		SYNCDELAY;
		EP4BCH=0;
		SYNCDELAY;
		EP4BCL=0x80;	//call it good;
	}
	if(!(EP2468STAT & bmEP2EMPTY))
	{
		SYNCDELAY;
		EP2BCH=0;
		SYNCDELAY;
		EP2BCL=0x80;	//call it good;
	}

	//send data to PC
	if(xfer_in)
	{
		while(!(EP68FIFOFLGS & 0x20  ));
		FIFORESET=0x80;
		FIFORESET=0x08;
		FIFORESET=0x00;
		for(i=0;i<13;i++)
		{
			EP8FIFOBUF[i]=commands[i];
		}
		EP8BCH=xfer_len[2];
		EP8BCL=xfer_len[3];
		xfer_in=FALSE;
	} 

	




  
} 


void TD_Init( void )
{

		CPUCS = bmCLKOE; 
		IFCONFIG = bmIFCLKSRC;

	OED=0xF;
	IOD=0;		
	PD_2=1;		//default to read

	OEA=3;
	IOA=0;

	OEB=0; //input mode for port B for now

		
		SYNCDELAY;                    // see TRM section 15.14
		REVCTL = 0x00;                // REVCTL.1=1; use "dynamic OUT automaticity"
		
		// An explaination of what all happens when REVCTL.1=1
		//  - dynamic out automaticity
		//    - enabled via REVCTL.1=1 (DYN_OUT)
		//      - means block auto arming of OUT endp's when turning on "auto mode"
		//    - allows cpu intervention when switching between AUTO and MANUAL modes
		//      - without having to reset the fifo
		//  - this feature is useful for applications that edit packet data...
		//    - REVCTL.1=0 not recommended for applications that "touch" data...
		
		SYNCDELAY;                   
		EP2CFG = 0xA2;
		SYNCDELAY;                   
		EP4CFG = 0xA0;              

		SYNCDELAY;                   
		EP6CFG = 0xE2;
		SYNCDELAY;                    
		EP8CFG = 0xE0;
		

		
		SYNCDELAY;                    // 
		FIFORESET = 0x80;             // activate NAK-ALL to avoid race conditions
		SYNCDELAY;                    // 
		FIFORESET = 0x02;             // reset, FIFO 2
		SYNCDELAY;                    // 
		FIFORESET = 0x04;             // reset, FIFO 4
		SYNCDELAY;                    // 
		FIFORESET = 0x06;             // reset, FIFO 6
		SYNCDELAY;                    // 
		FIFORESET = 0x08;             // reset, FIFO 8
		SYNCDELAY;                    // 
		FIFORESET = 0x00;             // deactivate NAK-ALL
		
		// 8-bit bus (WORDWIDE=0)...
		SYNCDELAY;                   
		EP2FIFOCFG = 0x00; 
		SYNCDELAY;                    
		EP2FIFOCFG = bmAUTOOUT;
		SYNCDELAY;         
		EP6FIFOCFG = bmZEROLENIN;
		SYNCDELAY;
		EP4FIFOCFG		&= 0xFE;	// Clear WordWide bit
		SYNCDELAY;
		EP8FIFOCFG		=bmAUTOIN; //&= 0xFE;	// Clear WordWide bit
		SYNCDELAY;
		
		// OUT endp's come up "unarmed" in the cpu domain
		// ...to "arm" the endp's when AUTOOUT=0 the cpu write's 
		//  (1)...OUTPKTEND w/skip=1 (N times) when REVCTL.0=1 (ENH_PKT)
		//     ...true even when AUTOOUT=1 for REVCTL.0=1
		
		//        SYNCDELAY;                    // 
		//        OUTPKTEND = 0x82;             // arm first buffer
		//        SYNCDELAY;                    // 
		//        OUTPKTEND = 0x82;             // arm second buffer
		//        SYNCDELAY;                    // 
		//        OUTPKTEND = 0x82;             // arm third buffer
		//        SYNCDELAY;                    // 
		//        OUTPKTEND = 0x82;             // arm fourth buffer
		//        SYNCDELAY;                    // 
		
		//  (2)...EPxBCL w/skip=1 (N times) when REVCTL.0=0 (ENH_PKT)
		
		SYNCDELAY;                    // 
		EP2BCL = 0x80;                // arm first buffer
		SYNCDELAY;                    // 
		EP2BCL = 0x80;                // arm second buffer
		SYNCDELAY;                    // 

		EP4BCL = 0x80;                
		SYNCDELAY;                    
		EP4BCL = 0x80;               
		SYNCDELAY;                    
		EP4BCL = 0x80;                
		SYNCDELAY;                    
		EP4BCL = 0x80;               
		SYNCDELAY;                    
  
		GPIFTCB3 = 0xFF;
		SYNCDELAY;                   
		GPIFTCB2 = 0xFF;
		SYNCDELAY;                    
		GPIFTCB1 = 0xFF;
		SYNCDELAY;                   
		GPIFTCB0 = 0xFF;
		SYNCDELAY;                   
		// trigger FIFO write transaction(s), using SFR
		// R/W=0, EP[1:0]=00 for EP2 write(s)
		//GPIFTRIG = GPIFTRIGWR | GPIF_EP2;  
		EP2GPIFTRIG=0xFF;
		SYNCDELAY; 
		// Note: had we choosen to use AUTOOUT=1 initially, then...
		//   (1)...when REVCTL.1=0, the core must see MANUAL-AUTO switch of AUTO bit
		//      ...to properly "arm" OUT buffers...
		//
		//         SYNCDELAY;         
		//         EP2FIFOCFG = 0x00; // AUTOOUT=0 (manual OUT mode)
		//         SYNCDELAY;         
		//         EP6FIFOCFG = 0x04;
		//    then,
		//         SYNCDELAY;         
		//         EP2FIFOCFG = 0x10; // AUTOOUT=1 (auto OUT mode)
		//         SYNCDELAY;         
		//         EP6FIFOCFG = 0x04;
		//
		//      ...this might not be obvious because the default is AUTOOUT=0
		//      ...power static back to back firmware downloads may be subject to 
		//      ...the above scheme.when the application's last status was AUTOOUT=1
		//
		//   (2)...when REVCTL.1=1, core blocks auto arming of OUT endp's
		//      ...see above EPxBCL/OUTPKTEND sequence(s)
		//      ...sequence is as follows:
		//      ...(a) REVCTL.1=1
		//      ...(b) FIFORESET (as above)
		//      ...(c) EPxBCL/OUTPKTEND (as above)
		//      ...(d) AUTOOUT=1
		
		
/*		
		INTSETUP |= 0x03;   // Enable INT4 FIFO/GPIF Autovectoring
		SYNCDELAY;          // used here as "delay"
		EXIF &=  ~0x40;     // just in case one was pending...
		SYNCDELAY;          // used here as "delay"
		GPIFIRQ = 0x02;
		SYNCDELAY;          // 
		GPIFIE = 0x02;      // Enable GPIFWF interrupt
		SYNCDELAY;          // 
		EIE |= 0x04;        // Enable INT4 ISR, EIE.2(EIEX4=1)
*/		
				
		
		
		
		
}








void main(void)
{

	
	TD_Init();
	


	EA = 0;                  // 8051 interrupts
	
	
	CKCON = 0; 
	

	
	status[0]=0x22;
	write_status(status);

	while(TRUE)               // Main Loop
	{
	TD_Poll();
	}
}




