/*
PC-USB server
Copyright (C) Destop/Crazynation 2004
*/
#include <windows.h>
#include <stdio.h>
#include <winioctl.h>
#include "ezusbsys.h"


void clrscr ();

extern BYTE USB_BOOT_HEX[];
extern BYTE FAKETOC[];
extern BYTE RING_SECTOR[];
extern BYTE RAW_SECTOR[];

extern int PRINT_LENGTH;


extern char helptext[];
extern int get32(char *buffer);
extern int disp_buffer(unsigned int disp_len,char buffer[]);
extern void gotoxy(int x, int y);

typedef enum _USBD_PIPE_TYPE {
    UsbdPipeTypeControl,
    UsbdPipeTypeIsochronous,
    UsbdPipeTypeBulk,
    UsbdPipeTypeInterrupt
} USBD_PIPE_TYPE;
typedef struct _USBD_PIPE_INFORMATION {
    //
    // OUTPUT
    // These fields are filled in by USBD
    //
    USHORT MaximumPacketSize;  // Maximum packet size for this pipe
    UCHAR EndpointAddress;     // 8 bit USB endpoint address (includes direction)
                               // taken from endpoint descriptor
    UCHAR Interval;            // Polling interval in ms if interrupt pipe 
    
    USBD_PIPE_TYPE PipeType;   // PipeType identifies type of transfer valid for this pipe
    PVOID PipeHandle;
    
    //
    // INPUT
    // These fields are filled in by the client driver
    //
    ULONG MaximumTransferSize; // Maximum size for a single request
                               // in bytes.
    ULONG PipeFlags;                                   
} USBD_PIPE_INFORMATION, *PUSBD_PIPE_INFORMATION;


typedef struct _USBD_INTERFACE_INFORMATION {
    USHORT Length;       // Length of this structure, including
                         // all pipe information structures that
                         // follow.
    //
    // INPUT
    //
    // Interface number and Alternate setting this
    // structure is associated with
    //
    UCHAR InterfaceNumber;
    UCHAR AlternateSetting;
    
    //
    // OUTPUT
    // These fields are filled in by USBD
    //
    UCHAR Class;
    UCHAR SubClass;
    UCHAR Protocol;
    UCHAR Reserved;
    
    PVOID InterfaceHandle;
    ULONG NumberOfPipes; 

    //
    // INPUT/OUPUT
    // see PIPE_INFORMATION
    USBD_PIPE_INFORMATION Pipes[6];


} USBD_INTERFACE_INFORMATION, *PUSBD_INTERFACE_INFORMATION;

typedef struct __usb_Dev_Descriptor__ {
    UCHAR bLength;
    UCHAR bDescriptorType;
    USHORT bcdUSB;
    UCHAR bDeviceClass;
    UCHAR bDeviceSubClass;
    UCHAR bDeviceProtocol;
    UCHAR bMaxPacketSize0;
    USHORT idVendor;
    USHORT idProduct;
    USHORT bcdDevice;
    UCHAR iManufacturer;
    UCHAR iProduct;
    UCHAR iSerialNumber;
    UCHAR bNumConfigurations;
} Usb_Device_Descriptor, *pUsb_Device_Descriptor;

int extended_key=FALSE;
int getkey()
{
	int i=0;
	extended_key=FALSE;
	i=getch();
	if(i==0 || i==0xE0)
	{
		i=getch();
		extended_key=TRUE;
	}
	return i&0xFF;
}
int getkey2()
{
	int i=0;
	if(kbhit())
	{
		i=getch();
		if(i==0 || i==0xE0)
			i=getch();
	}
	return i&0xFF;

}
unsigned long str2dec(char *ptr) {
 int  unsigned Bcl1;
 char *S,ThisByte;
 long Result=0;
 S=strupr(ptr);
 for (Bcl1=0;Bcl1<strlen(S);Bcl1++) {

  Result=Result*10;
  ThisByte=*(S+Bcl1)-('0');
 if (ThisByte>9)
  ThisByte=0;
  Result=Result+(ThisByte&0xFF);
  }
   return(Result);
}
unsigned long hex2dec(char *ptr) {
 int  Bcl1;
 char *S,ThisByte;
 long Result=0;
 S=strupr(ptr); 
 if (ptr[0]!='!')
 {
	for (Bcl1=0;Bcl1<strlen(S);Bcl1++) {
	ThisByte=*(S+Bcl1);
	if (!((ThisByte >= '0' && ThisByte <= '9') || (ThisByte >= 'A' && ThisByte <= 'F')))
		continue;
	ThisByte-=('0');
		if (ThisByte>9)
			ThisByte=ThisByte+(('0')-('A')+10);
	Result=Result<<4;
	Result=Result+(ThisByte&0xFF);
	}
 }
 else
 {
	for (Bcl1=1;Bcl1<strlen(S);Bcl1++) {
	Result=Result*10;
	ThisByte=*(S+Bcl1)-('0');
	Result=Result+ThisByte;
	}
 }
   return(Result);
}
void clrscr ()
{
 DWORD nchars;
 HANDLE handle = GetStdHandle (STD_OUTPUT_HANDLE);
 COORD xy_first = { 0, 0 };
  
 // fill scr buf with spaces, 'nchars' is not needed here
 FillConsoleOutputCharacter (handle, ' ',  80*60, xy_first, &nchars);
 SetConsoleCursorPosition (handle, xy_first); 
}


void FX2_COMMAND(HANDLE *hUSB,char com){
	int i,j;
	int pipe;
	BYTE command[8];
	command[0]=com;
	for(i=0;i<4;i++)
	command[1+i]=command;

	pipe=3;
	i=DeviceIoControl (hUSB,IOCTL_EZUSB_BULK_WRITE,
		&pipe,sizeof(BULK_TRANSFER_CONTROL),
		command,5,&j,NULL);


}
void FX2_READ_PIPE(HANDLE *hUSB,char *buffer,int length,int pipe){

	int j;

	DeviceIoControl (hUSB,IOCTL_EZUSB_BULK_READ,
		&pipe,sizeof(BULK_TRANSFER_CONTROL),
		buffer,length,&j,NULL);
}
void FX2_WRITE_PIPE(HANDLE *hUSB,char *buffer,int length,int pipe){

	int j;

	DeviceIoControl (hUSB,IOCTL_EZUSB_BULK_WRITE,
		&pipe,sizeof(BULK_TRANSFER_CONTROL),
		buffer,length,&j,NULL);
}

void FX2_READ_BULK(HANDLE *hUSB,char *buffer,int length){
	int i,j;
	int pipe;
	BYTE command[8];
	command[0]=0x12;
	for(i=0;i<4;i++)
	command[1+i]=length>>((3-i)*8);

	

	pipe=3;
	i=DeviceIoControl (hUSB,IOCTL_EZUSB_BULK_WRITE,
		&pipe,sizeof(BULK_TRANSFER_CONTROL),
		command,5,&j,NULL);

	pipe=5;
	if(length>0xFFFFFF)
	{
		for(i=0;i<length;i+=0xFFFF)
		{
		if((length-i)>=0xFFFF)
		DeviceIoControl (hUSB,IOCTL_EZUSB_BULK_READ,
			&pipe,sizeof(BULK_TRANSFER_CONTROL),
			buffer+i,0xFFFF,&j,NULL);
		else
		DeviceIoControl (hUSB,IOCTL_EZUSB_BULK_READ,
			&pipe,sizeof(BULK_TRANSFER_CONTROL),
			buffer+i,length-i,&j,NULL);

		}

	}
	else
	i=DeviceIoControl (hUSB,IOCTL_EZUSB_BULK_READ,
		&pipe,sizeof(BULK_TRANSFER_CONTROL),
		buffer,length,&j,NULL);
	i=GetLastError();
}

//write Bulk to pipe 2
void FX2_WRITE_BULK(HANDLE *hUSB,char *buffer,int len){
	int i,j;
	int pipe;
	pipe=2;
	i=DeviceIoControl (hUSB,IOCTL_EZUSB_BULK_WRITE,
		&pipe,sizeof(BULK_TRANSFER_CONTROL),
		buffer,len,&j,NULL);
}
//these control the cpu by writing bData to the memory mapped FX2 cpu control register
void FX2_HALT(HANDLE *h){
	unsigned long nbyte;
	VENDOR_REQUEST_IN vreq;

	vreq.bRequest = 0xA0;
	vreq.wValue = CPUCS_REG_FX2;
	vreq.wIndex = 0x00;
	vreq.wLength = 0x01;
	vreq.direction = 0x00;
	vreq.bData = 1;		//HALT
	DeviceIoControl (h,IOCTL_Ezusb_VENDOR_REQUEST,&vreq,sizeof(VENDOR_REQUEST_IN),NULL,0,&nbyte,NULL);
}
void FX2_RESUME(HANDLE *h){
	unsigned long nbyte;
	VENDOR_REQUEST_IN vreq;

	vreq.bRequest = 0xA0;
	vreq.wValue = CPUCS_REG_FX2;
	vreq.wIndex = 0x00;
	vreq.wLength = 0x01;
	vreq.direction = 0x00;
	vreq.bData = 0;			//RESUME
	DeviceIoControl (h,IOCTL_Ezusb_VENDOR_REQUEST,&vreq,sizeof(VENDOR_REQUEST_IN),NULL,0,&nbyte,NULL);
}

void FX2_WRITE_RAM(HANDLE *h,char *buffer,int addr,int len){
	unsigned long nbyte,i;
	VENDOR_OR_CLASS_REQUEST_CONTROL vreq;

	vreq.direction = 0;// transfer direction (0=host to device, 1=device to host)
	vreq.requestType = 2;// request type (1=class, 2=vendor)
	vreq.recepient = 0; // recipient (0=device,1=interface,2=endpoint,3=other)
	vreq.request = 0xA0;
	vreq.index = 0;	
	for(i=0;i<len;i+=0x1000)
	{
	vreq.value = addr+i; 		
	nbyte=DeviceIoControl (h,IOCTL_EZUSB_VENDOR_OR_CLASS_REQUEST,
		&vreq,sizeof(VENDOR_OR_CLASS_REQUEST_CONTROL),
		buffer+i,(len-i<0x1000)?len-i:0x1000, 
		&nbyte,NULL);
	}
	
}
void FX2_READ_RAM(HANDLE *h,char *buffer,int addr,int len){
	unsigned long nbyte,i;
	VENDOR_OR_CLASS_REQUEST_CONTROL vreq;

	vreq.direction = 1;// transfer direction (0=host to device, 1=device to host)
	vreq.requestType = 2;// request type (1=class, 2=vendor)
	vreq.recepient = 0; // recipient (0=device,1=interface,2=endpoint,3=other)
	vreq.request = 0xA0;
	vreq.index = 0;	
	for(i=0;i<len;i+=0x1000)
	{
	vreq.value = addr+i; 		
	nbyte=DeviceIoControl (h,IOCTL_EZUSB_VENDOR_OR_CLASS_REQUEST,
		&vreq,sizeof(VENDOR_OR_CLASS_REQUEST_CONTROL),
		buffer+i,(len-i<0x1000)?len-i:0x1000,
		&nbyte,NULL);
	}
}
void UPLOAD_Hex(HANDLE *hUSB, char *buffer)
{
	BYTE	temp[0x2000];
	BYTE	*record;	
	INTEL_HEX_RECORD  hexrecord;
	ANCHOR_DOWNLOAD_CONTROL downloadControl;
	DWORD	last,len,data,i;

	memset(temp,0,sizeof(temp));

	
	FX2_HALT(hUSB);	//HALT CPU
	record = strtok(buffer,":");
	last=-1;len=0;
	while (record)
	{
		sscanf(record+0,"%2x",&hexrecord.Length);
		sscanf(record+2,"%4x",&hexrecord.Address);
		sscanf(record+6,"%2x",&hexrecord.Type);	
		
		//since the hex format is so screwed up, try to grab as many CONSECUTIVE bytes
		//as possible and send in one chunk instead of piddly 2,4 16 byte crap
		if((last!=hexrecord.Address) && (len!=0))
		{
		DeviceIoControl (hUSB,
			IOCTL_EZUSB_ANCHOR_DOWNLOAD,
			&downloadControl,
			sizeof(ANCHOR_DOWNLOAD_CONTROL),
			temp,
			len,
			(unsigned long *)&i,
			NULL);
		len=0; //reset counter
		}
		if(len==0)
			downloadControl.Offset=hexrecord.Address;


		for (i=0; i<hexrecord.Length; i++)
		{
			unsigned char* myptr = record+8+(2 * i);
			sscanf(record+8+(2 * i),"%2x",&data); //get byte
			//temp[hexrecord.Address+i]=data;
			temp[len]=data;
			len++;

		}
		last=hexrecord.Address+hexrecord.Length;		//save for next go around

		record = strtok(NULL,":");
	}	



	FX2_RESUME(hUSB);	//HALT CPU

}



void Save_DATA(HANDLE *hUSB,char *buffer,int length,char *filename)
{
	int i,j;
	FILE *fout;
//	length&=-0x8000;

	fout=fopen(filename,"wb");
	if(fout==0)
		return;
	printf("\nBusy");

/*
	for(i=0;i<length;i+=0x8000)
	{
	FX2_READ_BULK(hUSB,buffer+i,0x8000);
	printf(".");
	}
*/

	FX2_READ_BULK(hUSB,buffer,length);
	fwrite(buffer,1,length,fout);
	fclose(fout);
	printf("\nDone");

}

void usage(char *progname)
{
   fprintf(stderr, "\nFX2-USB\n");
   fprintf(stderr, "Usage: %s [filename]\n", progname);
   fprintf(stderr, "\nor [-g] for file requester\n");
   exit(2);
}

void calculate_parity(BYTE *buffer)
{
	int i;
	BYTE j;
	j=0;
	for(i=0;i<11;i++)
		j+=buffer[i];
	buffer[11]=~j;
}


BYTE INT2BCD(BYTE i)
{
	return ((i / 10) << 4) | (i % 10);
}
int BCD2INT(int bcd)
{
	bcd=bcd&0xFF;
	return (bcd & 0xf) + ((bcd >> 4) * 10);
	
}
unsigned long MSF2LBA(unsigned long MSF)
/* convert MSF to LBA
   in:MSF = unsigned long MSF,	bit 0- 7:F
								bit 8-15:S
								bit16-23:M
   out: LBA
*/
{
 unsigned long i;
	i=BCD2INT(MSF>>16);
	i=(i<<8)|BCD2INT(MSF>>8);
	i=(i<<8)|BCD2INT(MSF);
	MSF=i+150;
 i=((MSF&0xff0000)>>16)*4500+
   ((MSF&0x00ff00)>> 8)*75  +
    (MSF&0x0000ff);
 i=i-150;
 return(i);
}

unsigned long LBA2MSF(unsigned long LBA) //BCD format!!
/* convert LBA to MSF
   in:LBA = unsigned long LBA number
   out: MSF = unsigned long,bit 0- 7:F
							bit 8-15:S
							bit16-23:M
*/
{
 unsigned long i,j;

// LBA=LBA+150;
 i=(LBA/4500);
 LBA=LBA-(i*4500);
 i=i*0x10000;
 j=(LBA/75);
 LBA=LBA-(j*75);
 i=i+(j*0x100)+LBA;
 j=INT2BCD(i>>16)<<16;
 j|=INT2BCD(i>>8)<<8;
 j|=INT2BCD(i);
 return j;

}



cook_sector(BYTE *buffer,int lba,int track)
{
	int i,j,k;
	BYTE temp[2352];
	BYTE subcode[12];
	int bit_shift=7;
	memcpy(temp,buffer,2352);

	subcode[0]=0x61;
	subcode[1]=track;
	if(lba<96)
	subcode[2]=0;
	else
	subcode[2]=1;	//index
	i=LBA2MSF(lba);
	subcode[3]=i>>16;
	subcode[4]=i>>8;
	subcode[5]=i;
	subcode[6]=0;
	i=LBA2MSF(lba-96);
	subcode[7]=i>>16;
	subcode[8]=i>>8;
	subcode[9]=i;
	subcode[10]=0;
	subcode[11]=0;

	for(i=0;i<98;i++) //frames
	{
		for(j=0;j<6;j++) //bytes in frame
		{
			switch(i) //take care of F/B sync byte
			{
				case 0:
				case 1:
					buffer[i*36+j*6]=0x80;
					break;
				case 2:
					if(j==0)
					buffer[i*36+j*6]=0x80;
					else if(j==1)
						buffer[i*36+j*6]=0x40;
					else
						buffer[i*36+j*6]=0xC0;
					break;
				case 3:
					if(j==0)
						buffer[i*36+j*6]=0xC0;
					else if(j==1)
						buffer[i*36+j*6]=0x00;
					else
						buffer[i*36+j*6]=0x80;
					break;
				default:
					if(j==0)
						buffer[i*36+j*6]=0x80;
					else if(j==1)
						buffer[i*36+j*6]=0x00;
					else
						buffer[i*36+j*6]=0x80;
					break;

			}

			//write subcode data
			if(i==0)
				buffer[i*36+j*6+3]=0x9F;
			else if(i==1)
				buffer[i*36+j*6+3]=0xFD;
			else
			{
				k=subcode[(i-2)>>3]>>bit_shift;
				k=(k&1)<<6;
				buffer[i*36+j*6+3]=k;
			}
		}
		if(bit_shift==0)
			bit_shift=7;
		else
			bit_shift--;
	}
	for(i=0,k=0;i<98;i++)
	{
		for(j=0;j<6;j++)
		{
		buffer[i*36+j*6+1]=temp[k+1];
		buffer[i*36+j*6+2]=temp[k];
		buffer[i*36+j*6+4]=temp[k+3];
		buffer[i*36+j*6+5]=temp[k+2];
		k+=4;
		}
	}
}

void dump_commands(HANDLE *hUSB)
{
	int i,j,key;
	BYTE buffer[40];
	FILE *file;

	file=fopen("dump.txt","wt");
	FX2_COMMAND(hUSB,0x13);	//saturn in control
	printf("press esc to stop\n");
	j=0;
	do{
	FX2_READ_BULK(hUSB,buffer,26);
	Sleep(5);
//	if(buffer[0]==0x9)
		j=1;
	if(j==1)
	{	
		if((buffer[11]!=0xFF) || (buffer[0]!=0))
			fprintf(file,"--");
		for(i=0;i<13;i++)
			fprintf(file,"%02X ",buffer[i]);
		fprintf(file,"\n");
		for(i=0;i<13;i++)
		fprintf(file,"%02X ",buffer[i+13]);
		fprintf(file,"\n");
		printf(".");
	}
	key=getkey2();
	}while(key!=0x1b);

	fclose(file);
}
int get_lba(BYTE *buffer)
{	
	int i;
	i=buffer[0]<<16;
	i|=buffer[1]<<8;
	i|=buffer[2];
	return i;
}
void read_ready_flag(HANDLE *hUSB,char *buffer)
{
	FX2_COMMAND(hUSB,0x19);
	FX2_READ_PIPE(hUSB,buffer,20,5);
}

void write_sector_data(HANDLE *hUSB, char *buffer)
{

	buffer[0]=0x18;
	FX2_WRITE_PIPE(hUSB,buffer,20,3);	//pipe 3 = EP4

}
void read_status(HANDLE *hUSB,char *buffer)
{

	FX2_COMMAND(hUSB,0x17);
	FX2_READ_PIPE(hUSB,buffer,20,5);
}
void write_status(HANDLE *hUSB,char *buffer)
{
	memmove(buffer+1,buffer,13);
	buffer[0]=0x16;
	FX2_WRITE_PIPE(hUSB,buffer,20,3);	//pipe 3 = EP4
}

void read_commands_new(HANDLE *hUSB,char *buffer)
{

	FX2_COMMAND(hUSB,0x14);
	FX2_READ_PIPE(hUSB,buffer,20,5);
}
void read_commands_current(HANDLE *hUSB,char *buffer)
{

	FX2_COMMAND(hUSB,0x15);
	FX2_READ_PIPE(hUSB,buffer,20,5);
}
void read_mod_step(HANDLE *hUSB,char *buffer)
{

	FX2_COMMAND(hUSB,0x12);
	FX2_READ_PIPE(hUSB,buffer,20,5);
}
void reset_mod_step(HANDLE *hUSB)
{

	FX2_COMMAND(hUSB,0x13);
}

void read_lba(HANDLE *hUSB,char *buffer)
{
	FX2_COMMAND(hUSB,0x1A);
	FX2_READ_PIPE(hUSB,buffer,20,5);

}
int main(int argc, char *argv[])
{
	FILE *file,*fout;
	char *filename=0,*progname;
	BYTE *buffer;
	BYTE commands[12];
	BYTE dev_name[256];
	int key=0;
	int setauto=0;
	int i,j;
	int printit=1;
	long offset=0,length;
	int	x=0;
	int	position=1;
	int fx2_mode=0;
	Usb_Device_Descriptor device_desc;

	HANDLE *hUSB;
	BULK_TRANSFER_CONTROL bulk_control;
    USBD_INTERFACE_INFORMATION InterfaceInfo;
	SET_INTERFACE_IN interface_info;
	BOOL Athreadstarted=FALSE;
	BOOL loopaudio=FALSE;


	progname=argv[0];

	printf("allocating xMB buffer\n");
	buffer=(char*)malloc(1024*1024*8);
	if(buffer==0)
	{
		printf("\nmalloc failed\n");
		exit(-1);
	}
	memset(buffer,0,1024*1024*8);


	printf("looking for device\n");

	for(i=0;i<6;i++)
	{
	sprintf((char *)dev_name,(char *)"\\\\.\\ezusb-%d",i);
	hUSB = CreateFile((char *)dev_name,GENERIC_WRITE,FILE_SHARE_WRITE,NULL,OPEN_EXISTING,0,NULL);
	 j=GetLastError();
		if(hUSB != INVALID_HANDLE_VALUE)
		{
		DeviceIoControl (hUSB,
			IOCTL_Ezusb_GET_DEVICE_DESCRIPTOR,
			&device_desc,
			sizeof (Usb_Device_Descriptor),
			&device_desc,
			sizeof (Usb_Device_Descriptor),
			(unsigned long *)&j,
			NULL);
			if(device_desc.idProduct!=0x8613)
			{
				CloseHandle(hUSB);
				continue;
			}
			else
				break;
		}
	}
	if(hUSB == INVALID_HANDLE_VALUE)
	{
	printf("device not found\n ...press any key\n");
	getch();
	usage(progname);
	}

#ifdef _DEBUG
	printf("found device:%s\n ...press any key\n",dev_name);
	key=getkey();
		if(key==0x1B)
			exit(0);
#endif
///////////////////////////////////////


	if (argc>1)
		if(strcmp(argv[1],"-g")==0)
			filename=OpenGame();
		else
			filename=argv[1];

	filename="dump.bin";
///////////////////////////////////////
UPLOAD_Hex(hUSB,USB_BOOT_HEX);
///////////////////////////////////////
/*
	key=DeviceIoControl (hUSB,
	IOCTL_Ezusb_GET_PIPE_INFO,
	NULL,
	0,
	&InterfaceInfo,
	sizeof(InterfaceInfo),
	&j,
	NULL);
*/
	// SET Interface to 0,1
	interface_info.interfaceNum=0;
	interface_info.alternateSetting=1;

	key=DeviceIoControl (hUSB,
	IOCTL_Ezusb_SETINTERFACE,
	&interface_info,
	sizeof(SET_INTERFACE_IN),
	NULL,
	0,
	(unsigned long *)&j,
	NULL);




redump:

	if (printit==1)
	{
		clrscr();
		i=0;
//		disp_buffer(0x100,buffer+offset);
		disp_buffer(0x40,buffer);
//		printf("\nspeed=%.1f kb/s: \n",(length/1024)/((speed)/1000)  );

		printf("F1 for help\n");
		printf("\noffset:%08X\n",offset);
		  printf("       ");
		  for(i=0;i<(7-position);i++)
			  printf(" ");
		  printf("*\n");	
#ifdef _DEBUG
		printf("key:0x%02X filename:%s\n",key,filename);
	i=LBA2MSF(offset);
	printf("MSF=%08X\n",i);
	i=MSF2LBA(offset);
	printf("LBA=%08X\n",i);
	printf("fx2_mode=%i\n",fx2_mode);
#else
		printf("filename:%s\n",filename);
#endif

	}

	key=0;
	if (setauto==0)
	{
	//F1=3b,3c,3d,3e f5=3f  f9=43,44,85,86 f12=8116
	key=getch();
	if (key==0)
		key=getch();
	}
	else if (kbhit())
	{
	key=getch();
	if (key==0)
		key=getch();
	}

//-------------------------------------
//	everything below here uses Alphabet
	if	(key>='a' && key<='z')
		key=key-('a'-'A');

	switch (key)
	{

		case '1':
			read_commands_new(hUSB,buffer);
			if(buffer[11]!=fx2_mode)
			{
				fout=fopen("log.txt","a+");
				for(i=0;i<13;i++)
				fprintf(fout,"%02X ",buffer[i]);
				fprintf(fout,"\n");
				fclose(fout);

			}

			fx2_mode=buffer[11];

			break;
		case '2':
			read_commands_current(hUSB,buffer);
			break;
		case '3':
			read_status(hUSB,buffer);
			break;
		case '4':
			read_ready_flag(hUSB,buffer);
			break;
		case '5':
			read_mod_step(hUSB,buffer);
			break;
		case '6':
			reset_mod_step(hUSB);
			break;
		case '7':
			read_lba(hUSB,buffer);
			break;
		case '8':
			FX2_COMMAND(hUSB,0x21); 
			FX2_READ_PIPE(hUSB,buffer,20,5);
			if(buffer[11]!=fx2_mode)
			{
				fout=fopen("log.txt","a+");
				for(i=0;i<13;i++)
				fprintf(fout,"%02X ",buffer[i]);
				fprintf(fout,"\n");
				fclose(fout);

			}

			fx2_mode=buffer[11];
			break;
		case 'Q':
			FX2_COMMAND(hUSB,0x1f); //lba offset
			FX2_READ_PIPE(hUSB,buffer,20,5);
			break;
		case 'W':
			FX2_COMMAND(hUSB,0x20); //lba offset
			FX2_READ_PIPE(hUSB,buffer,20,5);
			break;
		case 'A':
			FX2_COMMAND(hUSB,0x1D);	//read commands and CD status
			FX2_READ_PIPE(hUSB,buffer,30,5);

			if((buffer[11+13]!=fx2_mode)  )
			{
				fout=fopen("log.txt","a+");
				for(i=0;i<13;i++)
				fprintf(fout,"%02X ",buffer[i]);
				fprintf(fout,"\n");
				for(i=0;i<13;i++)
				fprintf(fout,"%02X ",buffer[i+13]);
				fprintf(fout,"\n");
				fprintf(fout,"\n");
				fclose(fout);

			}

			fx2_mode=buffer[11+13];
			break;
		case ' ':
			read_commands_new(hUSB,buffer+13*2);
			break;
		case '0':
			FX2_COMMAND(hUSB,0x1E);	//read starting lba
			FX2_READ_BULK(hUSB,buffer,20);

			break;
		case 'R':
			break;
		case 'Z':
			LBA2MSF(0x30000);
			*((BYTE*)&i)=0x11;
			i=0x11223344;
			j=(DWORD)*((BYTE*)&i+0);
			*((BYTE*)&i+1)=0x22;
			*((BYTE*)&i+2)=0x33;
			*((BYTE*)&i+3)=0x44;
				printf("%08X",i);
			getkey();
			break;
		case 0x1B:  //ESC
			goto exit;
			break;

		case 0x2B:	//+
			PRINT_LENGTH++;
			break;
		case 0x2D:	//-
			PRINT_LENGTH--;
			break;
			

	}
	if(extended_key==TRUE)
		switch(key)
	{
		case 0x4B:	//left
			position++;
			position&=7;
			break;
		case 0x4D:	//right
			position--;
			position&=7;
			break;
		case 0x48:	//up
			offset+=1<<(position*4);
			break;
		case 0x50: //down
			offset-=1<<(position*4);
			break;
		case 0x51:	//pgdown
			offset+=PRINT_LENGTH*10;
			break;
		case 0x49:	//pgup
			offset-=PRINT_LENGTH*10;
			break;
		case 0x86:
		case 0x8D:  //ctrl up
			offset-=PRINT_LENGTH;
			break;
		case 0x56:
		case 0x91:	//ctrl down
			offset+=PRINT_LENGTH;
			break;


		case 0x3B:	//F1
			clrscr();
			printf("%s",helptext);
			getch();
			break;
		case 0x3F: //F5
			filename=OpenGame();
			break;		
	}
	offset&=0x7FFFFF;
	goto redump;



exit:
	free(buffer);
	clrscr();
	return 0;

}
